void SETUP() {
  CheckLoadLibrary("libPWGCFebye");

  // Set the include paths
  gROOT->ProcessLine(".include PWGCFebye/EBYE");
  gROOT->ProcessLine(".include PWGCFebye/EBYE/BalanceFunctions");
  gROOT->ProcessLine(".include PWGCFebye/EBYE/LRC");
  gROOT->ProcessLine(".include PWGCFebye/EBYE/MeanPtFluctuations");

  // Set our location, so that other packages can find us
  gSystem->Setenv("PWGCFebye_INCLUDE", "PWGCFebye");
}

Int_t CheckLoadLibrary(const char* library) {
  // checks if a library is already loaded, if not loads the library

  if (strlen(gSystem->GetLibraries(Form("%s.so", library), "", kFALSE)) > 0)
    return 1;
  
  return gSystem->Load(library);
}
